org.springframework.aop.framework

## Interface AopProxyFactory

- All Known Implementing Classes:
    DefaultAopProxyFactory

      public interface AopProxyFactory

  Interface to be implemented by factories that are able to create AOP proxies based on `AdvisedSupport` configuration objects.

  Proxies should observe the following contract:

  - They should implement all interfaces that the configuration indicates should be proxied.
  - They should implement the `Advised` interface.
  - They should implement the equals method to compare proxied interfaces, advice, and target.
  - They should be serializable if all advisors and target are serializable.
  - They should be thread-safe if advisors and target are thread-safe.

  Proxies may or may not allow advice changes to be made. If they do not permit advice changes (for example, because the configuration was frozen) a proxy should throw an `AopConfigException` on an attempted advice change.

  Author:
    Rod Johnson, Juergen Hoeller

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AopProxy` | `createAopProxy(AdvisedSupport config)` Create an `AopProxy` for the given AOP configuration.

- - ### Method Detail

    - #### createAopProxy

          AopProxy createAopProxy(AdvisedSupport config)
                                  throws AopConfigException

      Create an `AopProxy` for the given AOP configuration.
      Parameters:
        `config` - the AOP configuration in the form of an AdvisedSupport object
      Returns:
        the corresponding AOP proxy
      Throws:
        `AopConfigException` - if the configuration is invalid